<template>
  <div class="page">
    <div
      v-if="routeFrom && routeFrom.name === 'Data'"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des données
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Datasets' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Jeux de données
      </span>
    </div>

    <b-container
      fluid
    >
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      />

      <h2>Nouveau jeu de données</h2>
      <ValidationObserver v-slot="{ handleSubmit, errors }">
        
          <b-row>
            <b-col
              cols="8"
              class="detail-forms"
              style="overflow-x: hidden;"
            >
            <form>
              <DatasetForm
                :mode="'addDataset'"
                :defaultForm="form"
                @change="setForm"
              />

              <h3 class="line-header">
                <img
                  src="@/assets/icons/form_description_file.svg"
                  alt="Icône fichier"
                > Donnée
              </h3>
              <div style="margin-left: 1em;">
                <ResourceCreator
                  :key="'resource-creator'"
                  :required="false"
                  @set="setResource"
                />
              </div>

              <h3
                class="line-header"
              >
                <img
                  src="@/assets/icons/files_ressources.svg"
                  alt="Icône calendrier"
                /> Annexes
              </h3>

              <div style="margin-left: 1em;">
                <ResourceCreator
                  :key="'annex-creator'"
                  :usedFor="'annexe'"
                  :required="false"
                  @set="setAnnexe"
                />
              </div>
            </form>
            </b-col>
            <b-col
              cols="4"
            >

              <div class="card-permissions-container">
                <DatasetCard
                  :dataset="form"
                  :img="form.thumbnail ? form.thumbnail : null"
                />
                <div class="side-footer">
                  <!-- FORM FOOTER -->
                  <b-button
                    id="create-dataset-with-annexe"
                    variant="primary"
                    @click="handleSubmit(createDataset)"
                  >
                    Enregistrer
                  </b-button>

                  <!-- FORM ERRORS -->
                  <div
                    v-if="Object.values(errors).some(el => el.length > 0)"
                    class="error-messages alert alert-danger"
                    role="alert"
                  >
                    <b-icon icon="exclamation-triangle-fill" font-scale="2" />
                    <h5 class="alert-heading">
                      Les champs suivants ne sont pas renseignés:
                    </h5>
                    <ul>
                      <div
                        v-for="(error, field) in errors"
                        :key="field"
                      >
                        <li
                          v-if="error[0]"
                        >
                          <b>{{ field }} :</b> {{ error[0] }}.
                        </li>
                      </div>
                    </ul>
                  </div>
                </div>
              </div>

            </b-col>
          </b-row>
        <!-- </form> -->
      </ValidationObserver>
    </b-container>
    <ResourceCreationModal
      :open="isResourceCreationModalOpen"
      :data="resourceInspectionData"
      @actions="createResource"
      @cancel="cancelResourceCreation"
      @hide="isResourceCreationModalOpen = false"
    />
  </div>
</template>

<script>
import DatasetCard from '@/components/Cards/DatasetCard.vue';
import DatasetForm from '@/components/Forms/DatasetForm.vue';
import ResourceCreationModal from '@/components/Modals/ResourceCreationModal.vue';
import ResourceCreator from '@/components/ResourceCreator.vue';
import AddAnnexe from '@/components/Forms/AddAnnexe.vue';

import { ValidationObserver } from 'vee-validate';

import { mapState, mapMutations, mapActions } from 'vuex';

import { slugify } from '@/utils';

export default {
  name: 'AddDataset',

  components: {
    ValidationObserver,
    DatasetCard,
    DatasetForm,
    ResourceCreationModal,
    ResourceCreator,
    AddAnnexe
  },

  data() {
    return {
      routeFrom: null,
      loading: false,
      coverageOptions: [
        { label: 'Région', code: 0 },
        { label: 'Territoire de compétence de l\'organisation', code: 1 },
        { label: 'Calculée sur la donnée', code: 2 }
      ],
      form: {
        display_name: null,
        description: null,
        keywords: [],
        categories: [],
        topics: [],
        kinds: [],
        recommendation: null,
        restriction: null,
        usergroup: null,
        datasetContacts: [],
        licence: null,
        copyright: null,
        granularity: null,
        coverage: null,
        frequence: null,
        publicationDate: null,
        lastUpdateDate: null,
        year: new Date().getFullYear(),
        lineage: null,
        resource: null,
        annexe: null,
        thumbnail: null
      },
      isResourceCreationModalOpen: false,
      isDatasetCreationModalOpen: false
    };
  },

  computed: {
    ...mapState('user-login', [
      'userData'
    ]),
    ...mapState('organisations', [
      'organisationsList'
    ]),
    ...mapState('datasets', [
      'datasetsCategories',
      'datasetsGranularities',
      'datasetsLicences',
      'datasetsTopics',
      'datasetsKinds',
      'datasetsRestrictions',
      'datasetsUpdateFrequencies',
      'lastCreatedDataset',
      'duplicatedDataset'
    ]),
    ...mapState('resources', [
      'resourceDataFormats',
      'resourceInspectionData',
      'currentResourceFileId',
      'lastCreatedResource'
    ])
  },

  created() {
    if (!this.userData.is_superuser) {
      this.SET_USERGROUPS_FILTERS({
        filter: 'usergroup__status__in',
        value: '2'
      });
      this.SET_USERGROUPS_FILTERS({
        filter: 'user__role__in',
        value: ['1', '2']
      });
    }

    if (this.duplicatedDataset) {
      this.form.display_name = this.duplicatedDataset.display_name.concat(' ', '(copie)');
      this.form.thumbnail = this.duplicatedDataset.thumbnail;
      this.form.description = this.duplicatedDataset.description;
      this.form.usergroup = this.duplicatedDataset.usergroup;
      let position = 1;
      this.form.datasetContacts.splice(0);
      for (const contact of this.duplicatedDataset.contacts) {
        contact.position = position;
        this.form.datasetContacts.push(contact);
        position += 1;
      }
      this.form.categories = this.duplicatedDataset.categories.map(el => el.display_name);
      this.form.topics = this.duplicatedDataset.topics.map(el => el.display_name);
      this.form.kinds = this.duplicatedDataset.kinds.map(el => el.id);
      this.form.licence = this.duplicatedDataset.license;
      this.form.copyright = this.duplicatedDataset.copyright;
      this.form.granularity = this.duplicatedDataset.granularity ? this.duplicatedDataset.granularity : '';
      this.form.coverage =
        this.coverageOptions.find(el => el.code === this.duplicatedDataset.geographical_coverage) ?
          this.coverageOptions.find(el => el.code === this.duplicatedDataset.geographical_coverage) : '';
      this.form.keywords = this.duplicatedDataset.tags;
      this.form.recommendation = this.duplicatedDataset.recommendation;
      this.form.restriction = this.duplicatedDataset.restriction ?
        this.datasetsRestrictions.find(el => el === this.duplicatedDataset.restriction) ?
          this.datasetsRestrictions.find(el => el === this.duplicatedDataset.restriction) :
          this.duplicatedDataset.restriction :
        null;
      this.form.publicationDate = this.duplicatedDataset.publication_date ? this.duplicatedDataset.publication_date.slice(0, 10) : '';
      this.form.lastUpdateDate = this.duplicatedDataset.last_update_date ? this.duplicatedDataset.last_update_date.slice(0, 10) : '';
      this.form.creationDate = null;
      this.form.revisionDate = null;
      this.form.frequence =
        this.duplicatedDataset.update_frequency ?
          this.datasetsUpdateFrequencies.find(el => el.value === this.duplicatedDataset.update_frequency) :
          null,
      this.form.year = this.duplicatedDataset.year;
      this.form.lineage = this.duplicatedDataset.lineage;
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.isResourceCreationModalOpen = false;
    });
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
      vm.routeFrom = from;
    });
  },
  beforeRouteLeave(to, from, next) {
    this.RESET_USERGROUPS_FILTERS();
    this.SET_DUPLICATED_DATASET(null);
    next();
  },

  methods: {
    ...mapMutations('usergroups', [
      'SET_USERGROUPS_FILTERS',
      'RESET_USERGROUPS_FILTERS'
    ]),
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('resources', [
      'SET_RESOURCE_INSPECTION_DATA',
    ]),
    ...mapMutations('datasets', [
      'SET_DUPLICATED_DATASET'
    ]),
    ...mapActions('datasets', [
      'GET_DATASETS_LIST',
      'CREATE_DATASET',
      'UPDATE_DATASET'
    ]),
    ...mapActions('resources', [
      'GET_RESOURCES_LIST',
      'INSPECT_FILE_UPLOAD',
      'INSPECT_FTP',
      'INSPECT_HREF',
      'CREATE_FILE_UPLOAD_RESOURCE',
      'CREATE_FTP_RESOURCE',
      'CREATE_HREF_RESOURCE',
      'DELETE_RESOURCE_FILE',
      'CREATE_FILE_UPLOAD_ANNEXE',
      'CREATE_FTP_ANNEXE',
      'CREATE_HREF_ANNEXE',
    ]),
    ...mapActions('dashboard', [
      'GET_DASHBOARD_TASKS'
    ]),

    setForm(e) {
      this.form = e;
    },

    setResource(e) {
      this.form.resource = e;
    },

    setAnnexe(e) {
      this.form.annexe = e;
    },

    createDataset() {
      const datasetData = {
        display_name: this.form.display_name,
        codename: slugify(this.form.display_name).substring(0, 100),
        usergroup: this.form.usergroup ? this.form.usergroup.id : '',
        usergroup_type: this.form.usergroup ? this.form.usergroup.usergroup_type.codename : '',
        is_active: true,
        description: this.form.description,
        thumbnail: this.form.thumbnail,
        ...(
          this.form.datasetContacts.length > 0 &&
          this.form.datasetContacts[this.form.datasetContacts.length - 1].name &&
          this.form.datasetContacts[this.form.datasetContacts.length - 1].email
        ) && {
          // eslint-disable-next-line no-unused-vars
          contacts: this.form.datasetContacts.map(({ position, ...el }) => { return el; })
        },
        categories: this.datasetsCategories.filter(el => this.form.categories.includes(el.display_name)),
        topics: this.datasetsTopics.filter(el => this.form.topics.includes(el.display_name)),
        kinds: this.datasetsKinds.filter(el => this.form.kinds.includes(el.id)),
        ...this.form.recommendation && { recommendation: this.form.recommendation },
        ...this.form.restriction && { restriction: this.form.restriction },
        tags: this.form.keywords,
        copyright: this.form.copyright,
        ...this.form.publicationDate && {
          publication_date: new Date(this.form.publicationDate).toISOString().split('T')[0]
        },
        ...this.form.publicationDate && {
          last_update_date: new Date(this.form.publicationDate).toISOString().split('T')[0]
        },
        ...this.form.frequence && {
          update_frequency: this.form.frequence.value
        },
        year: this.form.year,
        lineage: this.form.lineage,
        ...this.form.licence && { license: this.form.licence },
        ...this.form.granularity && { granularity: this.form.granularity },
        ...this.form.coverage && { geographical_coverage: this.form.coverage.code }
      };
      
      this.loading = true;
      this.CREATE_DATASET(datasetData)
        .then(() => {
          if (this.lastCreatedDataset) {
            if (this.form.annexe) {
              this.createAnnexe();
            } else if (this.form.resource) {
              this.createResource();
            } else {
              if (this.lastCreatedDataset.id) {
                const data = {
                  ...this.lastCreatedDataset,
                  usergroup: this.lastCreatedDataset.usergroup.id
                };
                this.UPDATE_DATASET({
                  id: this.lastCreatedDataset.id,
                  data: data
                })
                  .then(() => {
                    this.$router.push({ name: 'DatasetDetail', params: { id: this.lastCreatedDataset.id } });
                  })
                  .catch(() => {
                    this.$router.push({ name: 'DatasetDetail', params: { id: this.lastCreatedDataset.id } });
                  });
              }
            }
          } else {
            this.loading = false;
          }
        })
        .catch(() => {
          this.loading = false;
        });
    },

    createAnnexe() {
      if (this.form.annexe.type === 'file-upload') {
        const resourceAnnexeData = {
          ...this.form.annexe,
          usergroup_pk: this.lastCreatedDataset.usergroup.id,
          dataset: this.lastCreatedDataset.id
        };
        this.createFileUploadAnnexe(resourceAnnexeData);
      } else if (this.form.annexe.type === 'ftp') {
        const resourceAnnexeData = {
          ...this.form.annexe,
          data_format: this.form.annexe.format.codename,
          usergroup_pk: this.form.usergroup.id,
          dataset: this.lastCreatedDataset.id,
          href: this.form.annexe.selectedFtpFiles.map(el => el.value),
        };
        this.createFTPAnnexe(resourceAnnexeData);
      } else if (this.form.annexe.type === 'href') {
        const resourceAnnexeData = {
          ...this.form.annexe,
          usergroup_pk: this.form.usergroup.id,
          dataset: this.lastCreatedDataset.id,
          href: this.form.annexe.href,
        };
        this.createHrefAnnexe(resourceAnnexeData);
      }
    },

    createFileUploadAnnexe(resourceAnnexeData) {
      this.CREATE_FILE_UPLOAD_ANNEXE(resourceAnnexeData)
        .then(() => {
          if (this.form.resource) {
            this.createResource(resourceAnnexeData);
          } else {
            const data = {
              ...this.lastCreatedDataset,
              usergroup: this.lastCreatedDataset.usergroup.id
            };
            this.UPDATE_DATASET({
              id: this.lastCreatedDataset.id,
              data: data
            })
              .then(() => {
                this.afterCreationRequests();
                this.loading = false;
              })
              .catch(() => {
                this.afterCreationRequests();
                this.loading =false;
              });
          }
        })
        .catch(() => {
          this.loading = false;
        });
    },

    createFTPAnnexe(resourceAnnexeData) {
      this.CREATE_FTP_ANNEXE(resourceAnnexeData)
        .then(() => {
          if (this.form.resource) {
            this.createResource(resourceAnnexeData);
          } else {
            const data = {
              ...this.lastCreatedDataset,
              usergroup: this.lastCreatedDataset.usergroup.id
            };
            this.UPDATE_DATASET({
              id: this.lastCreatedDataset.id,
              data: data
            })
              .then(() => {
                this.afterCreationRequests();
                this.loading = false;
              })
              .catch(() => {
                this.afterCreationRequests();
                this.loading =false;
              });
          }
        })
        .catch(() => {
          this.loading = false;
        });
    },

    createHrefAnnexe(resourceAnnexeData) {
      this.CREATE_HREF_ANNEXE(resourceAnnexeData)
        .then(() => {
          if (this.form.resource) {
            this.createResource();
          } else {
            const data = {
              ...this.lastCreatedDataset,
              usergroup: this.lastCreatedDataset.usergroup.id
            };
            this.UPDATE_DATASET({
              id: this.lastCreatedDataset.id,
              data: data
            })
              .then(() => {
                this.afterCreationRequests();
                this.loading = false;
              })
              .catch(() => {
                this.afterCreationRequests();
                this.loading =false;
              });
          }
        })
        .catch(() => {
          this.loading = false;
        });
    },

    createResource() {
      if (this.form.resource.type === 'file-upload') {
        const resourceData = {
          ...this.form.resource,
          organisation: this.form.usergroup.id,
          format: this.form.resource.format,
          file: this.form.resource.file
        };
        this.createFileUploadResource(resourceData);
      } else if (this.form.resource.type === 'ftp') {
        const resourceData = {
          ...this.form.resource,
          data_format: this.form.resource.format.codename,
          href: this.form.resource.selectedFtpFiles.map(el => el.value),
        };
        this.createFTPResource(resourceData);
      } else if (this.form.resource.type === 'href') {
        const resourceData = {
          ...this.form.resource,
          data_format: this.form.resource.format.codename,
          href: this.form.resource.href,
        };
        this.createHrefResource(resourceData);
      }
    },

    createFileUploadResource(resourceData) {
      this.INSPECT_FILE_UPLOAD(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.form.usergroup.id,
                dataset_id: this.lastCreatedDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.lastCreatedDataset.id
                }
              }
            };
            this.CREATE_FILE_UPLOAD_RESOURCE({ data: data, async: true })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.afterCreationRequests();
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch(() => {
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.afterCreationRequests();
        });
    },

    createFTPResource(resourceData) {
      this.INSPECT_FTP(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.form.usergroup.id,
                dataset_id: this.lastCreatedDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.lastCreatedDataset.id
                }
              }
            };
            this.CREATE_FTP_RESOURCE({ data: data, async: true })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.afterCreationRequests();
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch(() => {
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.afterCreationRequests();
        });
    },

    createHrefResource(resourceData) {
      this.INSPECT_HREF(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.form.usergroup.id,
                dataset_id: this.lastCreatedDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.lastCreatedDataset.id
                }
              }
            };
            this.CREATE_HREF_RESOURCE({ data: data, async: false })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.afterCreationRequests();
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch((err) => {
          console.error(err);
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.afterCreationRequests();
        });
    },

    // Fired after each resource creation
    afterCreationRequests() {
      this.GET_DATASETS_LIST({
        direction: null,
        field: null
      });
      this.GET_RESOURCES_LIST({
        direction: null,
        field: null
      });
      this.SET_CURRENT_FORM({
        id: null,
        form: null
      });
      this.GET_DASHBOARD_TASKS({
        direction: null,
        field: null
      })
        .then(() => {
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });

      if (this.lastCreatedDataset.id) {
        this.$router.push({ name: 'DatasetDetail', params: { id: this.lastCreatedDataset.id } });
      }
    },

    cancelResourceCreation() {
      this.DELETE_RESOURCE_FILE(this.currentResourceFileId);
    }
  }
};
</script>

<style lang="less" scoped>
.add-dataset-form {
  margin-left: max(2em, auto);
  margin-right: max(2em, auto);
  form {
    min-width: 800px;
    max-width: 1000px;
  }
}

h2 {
  color: @blue;
  text-shadow: 0 0 2px @lightBlue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

.card-permissions-container {
  position: sticky;
  top: 10%;
  width: 100%;
  margin: 0 auto;

  .side-footer {
    width: 80%;
    button {
      margin: 0 auto;
    }
    .error-messages {
      margin-top: 2rem;
      .b-icon {
        margin-bottom: 0.5rem;
        width: 100%;
      }
      ul {
        padding-left: 1rem;
      }
    }
  }
}

</style>
